function [ output_args ] = generate_toy_dataset ( varargin )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

[X,Y]   = generate_toydata(1000, 'moons');
[XT,YT] = generate_toydata(100 , 'moons');

if nargin == 1
    disp('Test Set = 2000 samples. Training Set as 1/10 of Test Set');
    if isstr(varargin{1})
        save(varargin{1});
    end
end


if nargin == 2
    disp('Training Set as 1/10 of Test Set');
    if (isnumeric(varargin{2}))
        samples = varargin{2};
        [X,Y]   = generate_toydata(samples / 2,  'moons');
        [XT,YT] = generate_toydata(samples / 20, 'moons');
    end
    
    if isstr(varargin{1})
        save(varargin{1});
    end
end

if nargin == 3
    disp('Training Set as a subset of Test Set');
    if (isnumeric(varargin{2}))
        testsamples = varargin{2};
        [X,Y]   = generate_toydata(testsamples / 2,  'moons');
        
        if (isnumeric(varargin{3}))
            trainingsamples = varargin{3};

            XT = zeros(trainingsamples, 2);
            YT = zeros(trainingsamples, 1);

            tStart = tic;

            for i = 1:trainingsamples
                index = round(rand * trainingsamples + 0.5);

                %while (Y(index) == 0)
                %    index = round(rand * trainingsamples + 0.5);
                %end

                YT(i)    = Y(index);
                %Y (index)    = 0;

                XT(i, :) = X(index, :);
                %X (index, :) = [0, 0];

                X(index, :)  = [];
                Y(index)     = [];

            end

            toc(tStart);
            
            if isstr(varargin{1})
                filename = varargin{1};
                clear i index tStart testsamples trainingsamples varargin ;
                save(filename);
            end
        end
    end
end

    

end

