function [ output_args ] = test_out_of_sample_extension(tt_data, opt_options, gamma_train, file, saveimg)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

Z = oos_data_gen(tt_data);
Zsize = size(Z);
W = zeros(Zsize(1), 1);

k  = opt_options.kernel;
kp = opt_options.kernelparam;
nn = opt_options.nearestneighbors;
cl = opt_options.classifier;

options = ml_options('Kernel', k, 'KernelParam', kp, 'NN', nn);

options.gamma_A = gamma_train.gamma_A;
options.gamma_I = gamma_train.gamma_I;

XT = tt_data.XT;
YT = tt_data.YT;

X = tt_data.X;
Y = tt_data.Y;

classifier          = ml_train(XT, YT, options, cl);
        
[f,labels,test_err] = ml_test(classifier, Z, W);
%[f,labels,test_err] = ml_test(classifier, X, Y);
%test_err

%size(W)
%size(labels)

perc_err = size(find(W - labels ~= 0)) / size (W) * 100.0;

%fprintf('%s %.6f %s %.2f%% %s %.6f %s %.6f\n', 'Err=', error, '%Err=', perc_err, 'gA=', x(1), 'gI=', x(2));

%scalar_error = error;

%size(labels)
%return;

pos=find(labels==1);
neg=find(labels==-1);
unlab=find(labels==0);

markersize = 10;

%if ~isempty(unlab)
%plot(Z(unlab,1),Z(unlab,2),'ks'); hold on;
%plot(Z(pos,1),Z(pos,2),'rd','MarkerSize',markersize,'MarkerFaceColor','r','MarkerEdgeColor','k'); hold on;
%plot(Z(neg,1),Z(neg,2),'bo' ,'MarkerSize',markersize,'MarkerFaceColor','b','MarkerEdgeColor','k'); hold on;

lightgreen = [0.50, 0.99, 0.83];
lightblue  = [0.39, 0.58, 0.92];

%{
plot(Z(pos,1),Z(pos,2),'rd','MarkerSize',markersize,'MarkerFaceColor','g','MarkerEdgeColor','g', 'Marker', 's', 'Color', lightgreen);
hold on;
plot(Z(neg,1),Z(neg,2),'rd','MarkerSize',markersize,'MarkerFaceColor','b','MarkerEdgeColor','b', 'Marker', 's', 'Color', lightblue);
hold on;
%}

clf('reset');
%newplot;

plot(Z(pos,1),Z(pos,2),'rd','MarkerSize',markersize, 'Marker', 's', 'Color', lightgreen, 'MarkerFaceColor', lightgreen);
hold on;
plot(Z(neg,1),Z(neg,2),'rd','MarkerSize',markersize, 'Marker', 's', 'Color', lightblue,  'MarkerFaceColor', lightblue);
hold on;

%plot_toy_dataset(file, tt_data);
plot_toy_dataset(' ', tt_data);

%stripfile = strrep(file, '.mat', '');
stripfile = basefilename(file);

if (bitand(saveimg, 1) == 1)
    %disp('FIG');
    graphfile = strcat('eps/', stripfile, '.fig');
    saveas(gcf, graphfile, 'fig');
end
if (bitand(saveimg, 2) == 2)
    %disp('EPS');
    graphfile = strcat('eps/', stripfile, '.eps');
    saveas(gcf, graphfile, 'epsc');
end
if (bitand(saveimg, 4) == 4)
    %disp('PNG');
    graphfile = strcat('eps/', stripfile, '.png');
    saveas(gcf, graphfile, 'png');
end

end

