function outputdataset = wipeout_labels(dataset, n)
% wipeout_labels - Wipes out every label in the dataset, except n randomly
% choosen labels.

%{
dataset
size(dataset)

histogram = zeros(200, 1);

for i=1:10000000

    index = round(rand * 200 + 0.5);
    histogram(index) = histogram(index) + 1;
    
end

markersize = 5;

histogram(1)
histogram(200)

plot(histogram,'rd','MarkerSize',markersize, 'Marker', 's', 'Color', 'green', 'MarkerFaceColor', 'green');
%}

if n > size(dataset, 1)
    error(sprintf('The number of remaining labels can''t be greater than size(dataset)\n'));
end

outputdataset = zeros(size(dataset, 1), 1);

for i=1:n
    
    index = round(rand * size(dataset, 1) + 0.5);
    
    while (outputdataset(index) == dataset(index))
        index = round(rand * size(dataset, 1) + 0.5);
    end
    
    outputdataset(index) = dataset(index);
    
end

end

